Bullet = Object:extend()

function Bullet:new(x, y, width, height, angle, atype)
    self.x = x
    self.y = y
    self.width = width
    self.height = height
    self.angle = angle
    world:add(self, self.x, self.y, self.width, self.height)
    self.speed = 5
    self.type = atype
    if self.type == "seed" then
        self.isSeed = true
    end
    self.leftTime = 30
    self.active = false
    self.liveTime = 0
end

function Bullet:update(dt)
    local function bulletFilter(item, other)
      -- muon no va cham phai them cau lenh dieu kien nay
        if other.isBlock  then return 'touch' 
        elseif other.isPad  then return 'touch' end
    end
    local goalX, goalY = self.x + self.speed * math.cos(self.angle), self.y + self.speed * math.sin(self.angle)
    local actualX, actualY, cols, len = world:move(self, goalX, goalY, bulletFilter)
    self.x, self.y = actualX, actualY
    for i = 1, len do
        local other = cols[i].other
        if other.isPad and not self.active then
            self.active = true
            other.treeHold = other.treeHold - 1
        end
    end
    if self.active then
        self.leftTime = self.leftTime - 1
    end
    if self.leftTime <= 0 then
        table.insert(listOfPlant, Plant(self.x, self.y-15, math.random(3, 6), math.random(15, 20), math.random(9, 12), math.random(60, 120), 2, 3))
        self:boom()
    end
    self.liveTime = self.liveTime + 1
    if self.liveTime >= 100 then
        self:boom()
    end
    
end

function Bullet:boom()
    for bulnum, bulnow in ipairs(listOfBullets) do
	      if bulnow == self then
            world:remove(self)
            table.remove(listOfBullets, bulnum) 
            break 
        end
    end
end

function Bullet:draw()
    love.graphics.setColor(0, 1, 0)
    love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
end