CollectBullet = Object:extend()

function CollectBullet:new(x, y, width, height, xVel, color, decreaseSpeed)
    self.x = x
    self.y = y
    self.width = width
    self.height = height
    self.xSpeed = math.random(1, 3) * 0.25 * xVel
    self.ySpeed = math.random(2, 4) * 0.5 * -1
    self.xVel = xVel 
    self.color = color
    self.decreaseSpeed = decreaseSpeed
    self.opacity = 1
    self.isCollectBullet = true
    world:add(self, self.x, self.y, self.width, self.height)
    self.touchGround = false
end

function CollectBullet:update(dt)
    
    if self.ySpeed<10 then
        self.ySpeed = self.ySpeed+ 0.1
    end
  
    local function collectFilter(item, other)
        if other.isBlock  then 
            return 'touch'
        end
    end
    
    
    local goalX, goalY = self.x +self.xSpeed , self.y + self.ySpeed 
    local actualX, actualY, cols, len = world:move(self, goalX, goalY, collectFilter)
    self.x, self.y = actualX, actualY
    
    for i = 1, len do
        local other = cols[i].other
        if other.isBlock then 
            self.touchGround = true
        end
    end
    
    ------------
    if self.opacity > 0 and self.bye then
        self.opacity = self.opacity - self.decreaseSpeed
    end
        
    if self.opacity <= 0 then
        --print("bye!")
        self:boom()
    end
end

function CollectBullet:boom()
    for colnum, colnow in ipairs(listOfEffect) do
	      if colnow == self then
            world:remove(self)
            table.remove(listOfEffect, colnum) 
            break 
        end
    end
end

function CollectBullet:draw()
    if self.color == "orangefruit" then
        love.graphics.setColor(252/255, 144/255, 3/255)
    end
    love.graphics.rectangle("fill", self.x, self.y ,self.width, self.height)
end