Effect = Object:extend()

function Effect:new(x, y, width, height, xVel, color, decreaseSpeed)
    --x, y, width, height, xvel, color, movetype
    self.x = x
    self.y = y
    self.width = width
    self.height = height
    self.xSpeed = math.random(1, 3) * 0.25 * xVel
    self.ySpeed = math.random(2, 4) * 0.5 * -1
    self.xVel = xVel 
    self.color = color
    self.decreaseSpeed = decreaseSpeed
    self.opacity = 1
    world:add(self, self.x, self.y, self.width, self.height)
end

function Effect:update(dt)
    if self.ySpeed<10 then
        self.ySpeed = self.ySpeed+ 0.1
    end
  
    local function effectFilter(item, other)
        if other.isBlock  then 
            return 'touch' 
        end
    end
    local goalX, goalY = self.x +self.xSpeed , self.y + self.ySpeed 
    local actualX, actualY, cols, len = world:move(self, goalX, goalY, effectFilter)
    self.x, self.y = actualX, actualY
    ------------
    if self.opacity > 0 then
        self.opacity = self.opacity - self.decreaseSpeed
    end
        
    if self.opacity <= 0 then
        --print("bye!")
        self:boom()
    end
        
    
end

function Effect:boom()
    for efnum, efnow in ipairs(listOfEffect) do
	      if efnow == self then
            world:remove(self)
            table.remove(listOfEffect, efnum) 
            break 
        end
    end
end

function Effect:draw()
    if self.color == "Brownout" then
        love.graphics.setColor(0.6, 0.4, 0, self.opacity)
    end
    love.graphics.rectangle("fill", self.x, self.y ,self.width, self.height)
end