Fruit = Object:extend()

function Fruit:new(x, y, width, height, name, fruitHave)
    self.x = x
    self.y = y
    self.width = 10
    self.height = 10
    self.maxWidth = width
    self.maxHeight = height
    self.name = name
    self.canFall = false
    self.add1 = false
    self.fruitHave = fruitHave
end

function Fruit:update(dt)
    
    if self.canFall then 
        
        local function fruitFilter(item, other)
            if other.isBlock  then return 'touch' end
        end
        local goalX, goalY = self.x , self.y + 5
        local actualX, actualY, cols, len = world:move(self, goalX, goalY, fruitFilter)
        self.x, self.y = actualX, actualY
        
        for i=1,len do
            local other = cols[i].other
            if other.isBlock then
                self:boom()
                for i = 1, self.fruitHave do
                    table.insert(listOfEffect, CollectBullet(self.x, self.y + 12, math.random(10, 15), math.random(10, 15), -1, "orangefruit",  0.2))
                    table.insert(listOfEffect, CollectBullet(self.x + 12, self.y + 12,math.random(10, 15), math.random(10, 15), 1, "orangefruit",  0.2))
                end
            end
        end
    end
    if self.width < self.maxWidth then
        self.width = self.width + 0.05
    end
    if self.height < self.maxHeight then
        self.height = self.height + 0.05
        self.y = self.y - 0.05
    end
    
    if self.width >= self.maxWidth - 1 and self.height >= self.maxHeight - 1 then
        self.canFall = true
        if self.add1 == false then
            world:add(self, self.x, self.y, self.width, self.height)
            self.add1 = true
        end
    end
end

function Fruit:boom()
    for frnum, frnow in ipairs(listOfFruit) do
	      if frnow == self then
            world:remove(self)
            table.remove(listOfFruit, frnum) 
            break 
        end
    end
end

function Fruit:draw()
    love.graphics.setColor(1, 0.2, 0)
    love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
end