Leaf = Object:extend()

function Leaf:new(x, y, originWidth, originHeight, maxWidth, maxHeight, direction)
    self.x = x
    self.y = y
    self.width = originWidth
    self.height = originHeight
    self.maxWidth = maxWidth
    self.maxHeight = maxHeight
    world:add(self, self.x, self.y, self.width, self.height)
    self.isLeaf = true
    self.currentColor = {255, 255, 255}
    self.opacity = 100
    self.direction = direction
end

function Leaf:update(dt)
    if self.direction == "right" then
        if self.width < self.maxWidth then
            self.width = self.width + 0.05
        end
        if self.height < self.maxHeight then
            self.height = self.height + 0.05
            self.y = self.y - 0.05
        end
    end
    if self.direction == "left" then
        if self.width < self.maxWidth then
            self.width = self.width + 0.05
            self.x = self.x - 0.05
        end
        if self.height < self.maxHeight then
            self.height = self.height + 0.05
            self.y = self.y - 0.05
        end
    end
    world:update(self, self.x, self.y, self.width, self.height)
    
end 

function Leaf:draw()
   
    love.graphics.setColor(self.currentColor, self.opacity)
    love.graphics.setLineWidth(3)
    love.graphics.rectangle("line", self.x - 1, self.y - 1, self.width + 2, self.height + 2)
    love.graphics.setColor(0.2, 0.8, 0.2)
    love.graphics.setLineWidth(1)
    love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
end