function love.load()
    Object = require "classic"
    require "player"
    player = Player(400, 300)
    
    require "block"
    listOfBlocks = {}
    table.insert(listOfBlocks, Block(100, 400, 5000, 30))
    table.insert(listOfBlocks, Block(164, 100, 3000, 30))
    
    bump = require 'bump'
    world = bump.newWorld(32)
    
    require"waterdrop"
    listOfWaters = {}
    --waterdr = WaterDrop(300, 300, 5, -90)
    
    
    world:add(player, player.x, player.y, player.width, player.height)
    world:add(listOfBlocks[1], listOfBlocks[1].x, listOfBlocks[1].y, listOfBlocks[1].width, listOfBlocks[1].height)
    world:add(listOfBlocks[2], listOfBlocks[2].x, listOfBlocks[2].y, listOfBlocks[2].width, listOfBlocks[2].height)
    
    require "effect"
    listOfEffect = {}
    
    require "leaf"
    listOfLeaf = {}
    
    require "padpad"
    listOfPad = {}
    table.insert(listOfPad, Pad(listOfBlocks[1].x+30, listOfBlocks[1].y-10, 10, 10, 3))
    
    require "plant"
    listOfPlant = {}
    --table.insert(listOfPlant, Plant(listOfBlocks[1].x, listOfBlocks[1].y-20, 5, 20, 10, 80, 2, 3))
    --table.insert(listOfPlant, Plant(listOfBlocks[1].x + 30, listOfBlocks[1].y-25, 5, 25, 10, 120, 2, 2))
    
    require "fruit"
    listOfFruit = {}
    
    require "bullet"
    listOfBullets = {}
    
    require "collectbullet"

    Camera = require "Camera"
    camera = Camera()
    --camera:setFollowStyle('PLATFORMER')
    camera:setFollowStyle('SCREEN_BY_SCREEN')
    
    require "notification"
    listOfNotifications = {}
    
    
end

function love.update(dt)
    camera:update(dt)
    camera:follow(player.x, player.y)
    --print(#listOfWaters)
    player:update(dt)
    for i3, v3 in ipairs(listOfWaters) do
        v3:update(dt)
    end
    for i4, v4 in ipairs(listOfEffect) do
        v4:update(dt)
    end
    for i6, v6 in ipairs(listOfPlant) do
        v6:update(dt)
    end
    for i8, v8 in ipairs(listOfLeaf) do
        v8:update(dt)
    end
    for i10, v10 in ipairs(listOfFruit) do
        v10:update(dt)
    end
    for i12, v12 in ipairs(listOfBullets) do
        v12:update(dt)
    end
    for i14, v14 in ipairs(listOfPad) do
        v14:update(dt)
    end
    for i16, v16 in ipairs(listOfNotifications) do
        v16:update(dt)
    end
end


function love.keypressed(key)
    if key == "w" then
        if player.isGrounded then
            player.vy = -400
            player.isJumping = true
            player.isGrounded = false
            player.doubleJumpReload = 10
            player.startCount = true
        end
    
        if player.canDoubleJump then
            player.vy = -400
            player.isJumping = true
            player.isGrounded = false
            player.canDoubleJump = false
            player.doubleJumpReload = 10
            player.startCount = false
        end
        player.canStomp = true
    end
    
    if key == "space" then
        --world:remove(listOfLeaf[1])
        --table.remove(listOfLeaf, 1)
        if player.facing == "left" then
            table.insert(listOfWaters, WaterDrop(player.x+16, player.y+16, 10, 10, -1))
        elseif player.facing == "right" then
            table.insert(listOfWaters, WaterDrop(player.x+16, player.y+16, 10, 10,  1))
        end
      
    end
end

function love.mousepressed(x, y, button, istouch)
    if button == 1 then -- Versions prior to 0.10.0 use the MouseConstant 'left'
        if player.currentWeapon == "seed" and player.seedNum > 0 then
            local angle = math.atan2(y - (player.y + player.height / 2), x - (player.x + player.width / 2)) 
            table.insert(listOfBullets, Bullet(player.x + player.width / 2 - 2.5, player.y + player.height / 2 - 2.5, 5, 5, angle, "seed"))
            player.seedNum = player.seedNum - 1
        end
    end
    if button == 2 then
        local items, len = world:queryPoint(x,y, filter)
        for i = 1, len do
            if items[i].isPlayer then
                print("a")
                table.insert(listOfNotifications, Notification(player.x - 200, player.y, 200, 50, 4))
            elseif items[i].isPad then
                print("b")
            elseif items[i].isSeed then
                print("c")
            else
                
            end
        end
    end
end

function love.draw()
    camera:attach()
    player:draw()
    for i, v in ipairs(listOfBlocks) do
        v:draw()
    end
    
    for i2, v2 in ipairs(listOfWaters) do
        v2:draw()
    end
    for i5, v5 in ipairs(listOfEffect) do
        v5:draw()
    end
    for i7, v7 in ipairs(listOfPlant) do
        v7:draw()
    end
    for i9, v9 in ipairs(listOfLeaf) do
        v9:draw()
    end
    for i11, v11 in ipairs(listOfFruit) do
        v11:draw()
    end
    for i13, v13 in ipairs(listOfBullets) do
        v13:draw()
    end
    for i15, v15 in ipairs(listOfPad) do
        v15:draw()
    end
    for i17, v17 in ipairs(listOfNotifications) do
        v17:draw()
    end
    camera:detach()
    camera:draw()
end