Plant = Object:extend()

function Plant:new(x, y, originWidth, originHeight, maxwidth, maxheight, leafNum, fruithave)
    self.width = originWidth
    self.height = originHeight
    self.x = x
    self.y = y
    self.maxWidth = maxwidth
    self.maxHeight = maxheight
    self.averageHeight = self.maxHeight / 16
    self.fruitHave = fruithave
    self.fruitYet = "nope"
    
    world:add(self, self.x, self.y, self.width, self.height)
    self.leafNum = leafNum
    --- leaf 1 calculating
    self.calc1 = 0
    self.height1 = self.height
    while self.height1 < self.maxHeight do
        self.height1 = self.height1 + 0.05
        self.calc1 = self.calc1 + 0.05
    end
    self.rect1x = self.x + self.maxWidth
    self.rect1y = self.y + self.averageHeight *math.random(4, 6) - self.calc1
    ---
    
    --- leaf 2 calculating
    self.calc2 = 0
    self.height2 = self.height
    while self.height2 < self.maxHeight do
        self.height2 = self.height2 + 0.05
        self.calc2 = self.calc2 + 0.05
    end
    self.rect2x = self.x - 5
    self.rect2y = self.y + self.averageHeight *math.random(2, 4) - self.calc1
    ---
end

function Plant:update(dt)
    -- Filter function that returns true only for items that are leaves
    local function filterLeaves(item)
        return item.isLeaf
    end

    local items, len1 = world:queryRect(self.rect1x, self.rect1y, 10, 10, filterLeaves)
    if len1 < 1 and self.y < self.rect1y then
        --add a leaf somewhere in the rectangle where leaves can grow
            self.leafOne = table.insert(listOfLeaf, Leaf(self.rect1x, self.rect1y, 5, 5, self.averageHeight *math.random(3, 5), self.averageHeight*math.random(2, 3), "right"))
        
    end
    
    local items2, len2 = world:queryRect(self.rect2x, self.rect2y, 10, 10, filterLeaves)
    if len2 < 1 and self.y < self.rect2y then
        --add a leaf somewhere in the rectangle where leaves can grow
            self.leafTwo = table.insert(listOfLeaf, Leaf(self.rect2x, self.rect2y, 5, 5, self.averageHeight *math.random(3, 5), self.averageHeight*math.random(2, 3), "left"))
        
    end
    
    if self.width < self.maxWidth then
        self.width = self.width + 0.05
        
    end
    if self.height < self.maxHeight then
        self.height = self.height + 0.05
        self.y = self.y - 0.05
    end
    if self.height > self.maxHeight and self.fruitYet == "nope" then
        self.fruit = table.insert(listOfFruit, Fruit(self.x - self.width, self.y - 5, 30, 30, "bulletApple", self.fruitHave))
        self.fruitYet = "yep"
    end
    world:update(self, self.x, self.y, self.width, self.height)
end

function Plant:draw()
    love.graphics.setColor(0.2, 0.8, 0.2)
    love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
end